// CallocInflatable.h
//
// Copied (with possible minor changes) from:
// http://www.codeguru.com/Cpp/Cpp/cpp_mfc/buffers/article.php/c4113
// Inflable Arrays in Win32
// Petko Popov (view profile)
// September 21, 2001

#if !defined(__CALLOCINFLABLE_H__)
#define __CALLOCINFLABLE_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

__int32 UTL_CommitMemory(LPEXCEPTION_POINTERS ep,
                         void * pBaseAddress,
                         void * pLastAddress,
                         size_t dwElementSize);
void UTL_DecommitMemory(void * pBaseAddress,
                        size_t dwTotalSize);
void UTL_ReleaseMemory(void * pBaseAddress,
                       size_t dwTotalSize);

#define VIRTUAL_CALLOC(POINTER,NUMBER) \
   { \
      void *            __pBaseAddress = NULL; \
      void *            __pLastAddress = NULL; \
      size_t  __dwElementSize = sizeof(*POINTER); \
      size_t  __dwNumberOfElements = (NUMBER); \
      unsigned __int64  __qwTotalSize = \
                 (unsigned __int64)__dwElementSize * \
                 (unsigned __int64)__dwNumberOfElements; \
      __try { \
         __pBaseAddress   = \
                     ::VirtualAlloc(NULL, \
                                    (size_t)__qwTotalSize, \
                                    MEM_RESERVE, PAGE_READWRITE); \
         if ( __pBaseAddress == NULL ) { \
            __pLastAddress = NULL; \
            *((void**)&(POINTER)) = NULL; \
		 } else { \
            __pLastAddress = (char*)__pBaseAddress + __qwTotalSize; \
            *((void**)&(POINTER)) = __pBaseAddress; \
		 } \
         __try {

#define VIRTUAL_FREE \
     } __except ( \
          __pBaseAddress != NULL && \
          ::GetExceptionCode() == EXCEPTION_ACCESS_VIOLATION ? \
                   UTL_CommitMemory(GetExceptionInformation(), \
                                    __pBaseAddress, \
                                    __pLastAddress, \
                                    __dwElementSize) : \
                        EXCEPTION_CONTINUE_SEARCH ) { \
         } \
      } __finally { \
         if (__pBaseAddress != NULL) UTL_ReleaseMemory(__pBaseAddress, \
                           (size_t)__qwTotalSize); \
      } \
   }

#define VIRTUAL_RESET \
   UTL_DecommitMemory(__pBaseAddress, \
                     (size_t)__qwTotalSize);

#endif // #if !defined(__CALLOCINFLABLE_H__)

