#include "StdAfx.h"
#include "RootPointer.h"
#include "MutableList.h"

MutableList::MutableList():
	m_head(NULL),
	m_tail(NULL),
	m_iterator(NULL)
{
}
void MutableList::Link(RootPointer * item)
{
	item->m_next = NULL;
	item->m_prev = NULL;
	if (m_head == NULL)
	{
		m_head = m_tail = item;
		m_iterator = item;
	}
	else
	{
		item->m_prev = m_tail;
		m_tail->m_next = item;
		m_tail = item;
		if (m_iterator == NULL)
		{
			m_iterator = item;
		}
	}
}

void MutableList::Unlink(RootPointer * item)
{
	if (item == m_iterator)
	{
		Next();
	}
	RootPointer * prev = item->m_prev;
	RootPointer * next = item->m_next;
	if (prev != NULL)
	{
		prev->m_next = next;
	}
	if (next != NULL)
	{
		next->m_prev = prev;
	}
	if (item == m_head)
	{
		m_head = next;
	}
	if (item == m_tail)
	{
		m_tail = prev;
	}
	item->m_prev = NULL;
	item->m_next = NULL;
}

void MutableList::Start()
{
	m_iterator = m_head;
}

RootPointer * MutableList::Current()
{
	return m_iterator;
}

void MutableList::Next()
{
	m_iterator = m_iterator->m_next;
}

bool MutableList::IsLast(RootPointer * item)
{
	return item == m_tail;
}
