#pragma once

struct internal_error {};

struct MasterPointer;

class RootPointer
{
public:
	RootPointer();
	RootPointer(const RootPointer & other);
	~RootPointer();
	RootPointer & operator=(const RootPointer & other);
	bool IsNull() const;
	RootPointer Car() const;
	RootPointer Cdr() const;
	int & Int();
	double & Double();

	// Mutators, require additional
	// work with the GC:
	RootPointer & SetCar(const RootPointer & car);
	RootPointer & SetCdr(const RootPointer & cdr);

	RootPointer * m_prev;
	RootPointer * m_next;
private:
	void GlobalLink();
	void GlobalUnlink();
	friend RootPointer Cons(const RootPointer & car, const RootPointer & cdr);
	friend void ScanPointer(RootPointer * rootPointer);
	MasterPointer * m_ptr;
};
